﻿package nicocache.controls
{
    import flash.events.MouseEvent;
    
    import mx.controls.CheckBox;
    import mx.controls.dataGridClasses.DataGridColumn;
    import mx.controls.listClasses.IListItemRenderer;
    import mx.containers.HBox;

    import nicocache.log.Logger;
    import nicocache.utils.BooleanUtil;

    /**
     * チェックボックスを表示するレンダラーです。
     * 
     */
    public class CheckBoxItemRenderer extends HBox implements IListItemRenderer
    {

        public var checkBox:CheckBox;
    
        private var dataField:String;

        /**
         * コンストラクタ
         * 
         */
        public function CheckBoxItemRenderer()
        {
            super();

            setStyle("horizontalAlign", "center");
            setStyle("paddingLeft", "2");
        }
        
        /**
         * チェックボックスを追加します。
         * 
         */
        protected override function createChildren():void
        {
            super.createChildren();
            if (!checkBox)
            {
                checkBox = new CheckBox();
                addChild(checkBox);
                checkBox.addEventListener(MouseEvent.CLICK, clickCheckBox, false, 0, true);
            }
            var column:DataGridColumn = styleName as DataGridColumn;
            dataField = column.dataField;
        }

        /**
         * チェックボックスの状態を設定します。
         * 
         */
        protected override function commitProperties():void
        {
            super.commitProperties();
            
            if (data != null)
            {
                checkBox.selected = BooleanUtil.parseBoolean(data[dataField]);
            }
        }

        /**
         * 表示リスト更新時の処理
         * 
         */
        protected override function updateDisplayList(unscaledWidth:Number,unscaledHeight:Number):void
        {
            if (data != null)
            {
                checkBox.selected = BooleanUtil.parseBoolean(data[dataField]);
            }
            super.updateDisplayList(unscaledWidth, unscaledHeight);
        }
        
        /**
         * チェックボックスをクリックした時の処理
         * 
         */
        private function clickCheckBox(event:MouseEvent):void
        {
            data[dataField] = String(checkBox.selected); 
        }
    }
}
