﻿package nicocache.controls.column
{
    import nicocache.Constant;
    import mx.formatters.DateFormatter;
    import nicocache.controls.column.CustomColumn;
    import nicocache.controls.NumberItemRenderer;
    import mx.controls.dataGridClasses.DataGridColumn;
    import mx.core.ClassFactory;
    
    /**
     * 更新日付カラム
     *
     */
    public class LastModifyColumn extends CustomColumn
    {
        private static var formatter:DateFormatter = new DateFormatter();

        /**
         * コンストラクタ
         *
         */
        public function LastModifyColumn()
        {
            super();
            // デフォルト値設定
            dataField           = Constant.DATAFIELD_LASTMODIFY;
            headerText          = "更新日付";
            width               = 120;
            minWidth = 50;
            resizable           = true;
            sortable            = true;
            itemRenderer        = new ClassFactory(NumberItemRenderer);
            sortCompareFunction = dateSortFunction;
            rendererIsEditor    = false;
            showDataTips        = true;
            labelFunction       = dateLabelFunction;
        }

        /**
         * 更新日付の比較を行います。
         *
         * @param obj1 比較対象オブジェクト1
         * @param obj2 比較対象オブジェクト2
         * @return 同じなら0、小さい場合は-1、大きい場合は1を返す
         */
        protected function dateSortFunction(obj1:Object, obj2:Object):int
        {
            var id1:Number = Number(XMLList(obj1).@lastmodify);
            var id2:Number = Number(XMLList(obj2).@lastmodify);
            return compareValues(id1, id2);
        }

        /**
         * ラベルの生成を行います。
         *
         * @param item 対象セルの行データ
         * @param column 対象セルの列データ
         * @return ラベル
         */
        protected function dateLabelFunction(item:Object, column:DataGridColumn):String
        {
            var label:String = "";

            if (item != null)
            {
                var date:Date = new Date();

                date.time = Number(item[column.dataField]) * 1000;
                formatter.formatString = "YYYY/MM/DD JJ:NN:SS"
                label = formatter.format(date);
            }
            return label;
        }

    }
}
