﻿package nicocache.folder
{
    import nicocache.log.Logger;
    import nicocache.Constant;

    public class FolderInfo
    {
        public var name:String = null;
        public var view:String = null;
        public var path:String = null;
        public var type:String = null;
        public var filetype:String = null;
        public var reload:String = null;
        public var size:Number;
        public var count:Number;

        /** インスタンス */
        private static var instance:FolderInfo = null;

        /**
         * コンストラクタ
         *
         * @param blocker ブロック
         */
        public function FolderInfo(blocker:Blocker=null)
        {
            if (blocker == null) throw new Error("getInstance()を使用してください。");
        }

        /**
         * インスタンスを取得します。
         *
         * @return インスタンス
         */
        public static function getInstance():FolderInfo 
        {
            if (instance == null) instance = new FolderInfo(new Blocker());
            return instance;
        }

        /**
         * フォルダの情報を設定します。
         *
         * @param xml dirエレメント
         */
        public function set(xml:XML):void
        {
            view = xml.@view;

            if (view == Constant.VIEW_CACHE)
                type = Constant.TYPE_CACHELIST;
            else if (view == Constant.VIEW_ALL)
                type = Constant.TYPE_CACHELISTALL;
            else if (view == Constant.VIEW_TEMP)
                type = Constant.TYPE_TEMPLIST;
            else
            {
                Logger.warn("フォルダ一覧取得失敗");
                return;
            }
            
            name     = xml.@name;
            path     = xml.@path;
            filetype = "flv,mp4,swf";
            reload   = "false";
        }

        /**
         * フォルダ情報が設定されているかどうか。
         *
         * @return trueならフォルダ情報が設定されています
         */
        public function get state():Boolean
        {
            return (name != null) && (path != null) && (filetype != null) && 
                   (reload != null) && (view != null);
        }

        /**
         * フォルダ情報をクリアします。
         *
         */
        public function reset():void
        {
            path     = null;
            type     = null;
            name     = null;
            view     = null;
            filetype = null;
            reload   = null;
            size = 0;
            count = 0;
        }

        /**
         * フォルダ情報をMapで取得します。
         *
         * @return フォルダ情報
         */
        public function get():Object
        {
            var obj:Object = new Object();
            obj.name     = name;
            obj.path     = path;
            obj.filetype = filetype;
            obj.type     = type;
            obj.reload   = reload;

            return obj;
        }
    }

}

class Blocker 
{ }

