﻿package nicocache.log
{
    /**
     * ロガーハンドラインターフェース
     * 
     */
    public interface LoggerHandler
    {
        /**
         * デバッグログを表示します。
         * 
         * @param	message メッセージ
         * @param	... args 可変引数
         */
        function debug(message:String, ... args):void;
        
        /**
         * 情報ログを表示します。
         * 
         * @param	message メッセージ
         * @param	... args 可変引数
         */
        function info(message:String, ... args):void;
        
        /**
         * 警告ログを表示します。
         * 
         * @param	message メッセージ
         * @param	... args 可変引数
         */
        function warn(message:String, ... args):void;
        
        /**
         * エラーログを表示します。
         * 
         * @param	message メッセージ
         * @param	... args 可変引数
         */
        function error(message:String, ... args):void;
    }
}

